Subject: bug#65803: 29.1; Noto Sans Mono CJK JP has doubled-width on Windows

From: Po Lu <[email-masked]>
Date: Sun, 10 Sep 2023 13:55:47 +0800

Eli Zaretskii <[email-masked]> writes:

> No, the purpose of FRAME_COLUMN_WIDTH is much more than just "the
> width of ASCII characters".  It is used as the canonical character
> width of the frame, for gazillion purposes.  One example which
> triggered this bug is :align-to display spec, something utterly
> unrelated to ASCII characters.

However, the column width has hitherto been defined to the average width
of the frame font's ASCII characters.  At least outside W32, that is.

> But other font back-ends don't compute average_width for fixed-pitch
> fonts, so are you only talking about proportional fonts here?

I'm talking about fonts in general: since fixed pitch fonts are meant to
incorporate uniformly sized glyphs, the width of the space glyph should
represent the average width of any subset of the font's glyphs.  In this
particular case, Fontconfig doesn't deem the font in question a fixed
pitch font, and thus Emacs measures the average width of each ASCII
character itself.